#include <stdio.h>

#define USER_KEY 0x1234abcd
#define FILENAME "test.dat"
#define ACTIVATION_CODE 42
typedef unsigned int uint;
typedef uint* waddr_t;

uint player_key = 0xbabeca75;
uint the_key;
uint* key = &the_key;
FILE* audio;

int activation_code = 42;

int play(uint user_key, uint encrypted_media[], int media_len) {
  int code;
  printf("Please enter activation code: ");
  scanf("%i", &code);
  if (code!=ACTIVATION_CODE) {
    fprintf(stderr, "%s!\n", "wrong code");
    return -1;
  }

  *key = user_key ^ player_key;
  printf("key: %x\n", *key);

  int i;
  for(i=0; i<media_len; i++) {
    uint decrypted = *key ^ encrypted_media[i];
    printf("dec[%d]: %x\n", i, decrypted);
    fprintf(audio, "%x\n", decrypted);
    fflush(audio);
  }
}

int main (uint argc, char *argv[]) {
  uint user_key = USER_KEY;
  uint encrypted_media[]={0x12314f, 0x2121214, 0xf4324122, 0x1111FFFF, 0x90901a1a};
  uint media_len = sizeof(encrypted_media) / sizeof(uint);

  audio = fopen(FILENAME, "w");
  if(audio==NULL) {
    fprintf(stderr, "can't open %s\n", FILENAME);
    return -1;
  }

  play(user_key, encrypted_media, media_len);

  return 0;
}

